DlFileStreamOutputter subclass: #DlStSourceOutputter
	instanceVariableNames: 'timestamp '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-outputter-st'!
!DlStSourceOutputter commentStamp: 'mu 1/3/2001 00:00' prior: 0!
I write class category contents in simple text format.
I am implemented for Poor Man's Source Management System for Smalltalk.(PMSST).
Currently PMSST is just on experimental bases. 
I do not check diffs and generate many, many files. So if you use FAT16, beware the disk space!!

#creator
[:masashi | ^umezawa] 
#version 0.1!


!DlStSourceOutputter methodsFor: 'actions-output' stamp: 'mu 12/16/2000 19:14'!
outputAllClassMethods
	self analysisStorage getAllClassMethods do: 
		[:each | 
		| nm mcat cls ccat str pathArr | 
		nm := each name.
		mcat := each category.
		cls := mcat klass.
		ccat := cls category.
		pathArr := Array
					with: ccat name asFileName
					with: cls name , ' class'
					with: mcat name asFileName.
		str := self outStreamNamed: nm , '.mtd' in: pathArr.
		str isNil ifFalse: [self writeMethodSourceFor: each].
		str close]! !

!DlStSourceOutputter methodsFor: 'actions-output' stamp: 'mu 12/16/2000 19:23'!
outputAllClasses
	timestamp := Date dateAndTimeNow printString.
	self analysisStorage getAllClasses do: 
		[:each | 
		| nm mcat cls ccat str pathArr | 
		nm := each name.
		ccat := each category.
		pathArr := Array with: ccat name asFileName with: each name.
		str := self outStreamNamed: nm , '.cls' in: pathArr.
		str isNil ifFalse: [self writeClassSourceFor: each].
		str close]! !

!DlStSourceOutputter methodsFor: 'actions-output' stamp: 'mu 12/16/2000 19:14'!
outputAllInstMethods
	self analysisStorage getAllInstMethods do: 
		[:each | 
		| nm mcat cls ccat str pathArr | 
		nm := each name.
		mcat := each category.
		cls := mcat klass.
		ccat := cls category.
		pathArr := Array
					with: ccat name asFileName
					with: cls name
					with: mcat name asFileName.
		str := self outStreamNamed: nm , '.mtd' in: pathArr.
		str isNil ifFalse: [self writeMethodSourceFor: each].
		str close]! !


!DlStSourceOutputter methodsFor: 'actions-writing' stamp: 'mu 12/16/2000 19:23'!
writeClassSourceFor: aDlAnalyzableClass
	|  outStr |
	outStr := self outStream setToEnd.
	outStr cr.
	outStr nextPutAll: '" ', timestamp, ' <"'.
	outStr cr. 
	outStr nextPutAll: aDlAnalyzableClass target definition.
	outStr cr; cr. 
	outStr nextPutAll: '"-class-"'.
	outStr cr. 
	outStr nextPutAll: aDlAnalyzableClass target class definition.
	outStr cr. 
	outStr nextPutAll: '" ', timestamp, ' >"'.
	outStr cr. ! !

!DlStSourceOutputter methodsFor: 'actions-writing' stamp: 'MU 12/13/2000 02:33'!
writeMethodSourceFor: aDlAnalyzableMethod
	|  outStr |
	outStr := self outStream setToEnd.
	outStr cr.
	outStr nextPutAll: '" ', timestamp, ' <"'.
	outStr cr. 
	outStr nextPutAll: aDlAnalyzableMethod source.
	outStr cr. 
	outStr nextPutAll: '" ', timestamp, ' >"'.
	outStr cr. ! !


!DlStSourceOutputter methodsFor: 'factory' stamp: 'MU 12/13/2000 02:29'!
defaultActionSequence
	^#(
	#outputAllClasses
	#outputAllInstMethods
	#outputAllClassMethods
	).! !


!DlStSourceOutputter methodsFor: 'testing' stamp: 'MU 12/13/2000 02:24'!
shouldClearPreviousOutput
	^false! !


!DlStSourceOutputter methodsFor: 'private' stamp: 'mu 12/16/2000 19:11'!
convertFilenameForPathname: aString
	^aString asFileName! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlStSourceOutputter class
	instanceVariableNames: 'forbiddenCharTable '!

!DlStSourceOutputter class methodsFor: 'examples' stamp: 'mu 12/16/2000 19:56'!
backupDandelionAllSources
	"DlStSourceOutputter backupDandelionAllSources"
	| dandelion |
	dandelion := DlDandelionSystem new.
	dandelion analysisStrategy: DlSimpleAnalysisStrategy new.
	dandelion outputter: DlStSourceOutputter new.
	dandelion outputter outRootPathArray: #('DandelionSources').
	dandelion analyzeOutputMatches: 'Dandelion-*'.! !

!DlStSourceOutputter class methodsFor: 'examples' stamp: 'MU 12/13/2000 02:00'!
example1
	| dandelion |
	dandelion := DlDandelionSystem new.
	dandelion analysisStrategy: DlSimpleAnalysisStrategy new.
	dandelion analyze: #('Dandelion-analyzable').
	dandelion outputter: (DlStSourceOutputter new).
	dandelion output! !


!DlStSourceOutputter class methodsFor: 'class initialization' stamp: 'mu 12/16/2000 18:52'!
initialize
	"DlStSourceOutputter initialize"
	forbiddenCharTable := IdentityDictionary new.
	( Smalltalk platformName = 'Win32') ifTrue: [
	
	]! !

DlStSourceOutputter initialize!